# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from mtmai.clients.rest.models.agent_connected_event import AgentConnectedEvent
from mtmai.clients.rest.models.agent_error_event import AgentErrorEvent
from mtmai.clients.rest.models.agent_run_scheduled_event import AgentRunScheduledEvent
from mtmai.clients.rest.models.agent_scheduled_event import AgentScheduledEvent
from mtmai.clients.rest.models.agent_toast_event import AgentToastEvent
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

AGENTOUTGOINGEVENT_ONE_OF_SCHEMAS = ["AgentConnectedEvent", "AgentErrorEvent", "AgentRunScheduledEvent", "AgentScheduledEvent", "AgentToastEvent"]

class AgentOutgoingEvent(BaseModel):
    """
    AgentOutgoingEvent
    """
    # data type: AgentScheduledEvent
    oneof_schema_1_validator: Optional[AgentScheduledEvent] = None
    # data type: AgentRunScheduledEvent
    oneof_schema_2_validator: Optional[AgentRunScheduledEvent] = None
    # data type: AgentErrorEvent
    oneof_schema_3_validator: Optional[AgentErrorEvent] = None
    # data type: AgentToastEvent
    oneof_schema_4_validator: Optional[AgentToastEvent] = None
    # data type: AgentConnectedEvent
    oneof_schema_5_validator: Optional[AgentConnectedEvent] = None
    actual_instance: Optional[Union[AgentConnectedEvent, AgentErrorEvent, AgentRunScheduledEvent, AgentScheduledEvent, AgentToastEvent]] = None
    one_of_schemas: Set[str] = { "AgentConnectedEvent", "AgentErrorEvent", "AgentRunScheduledEvent", "AgentScheduledEvent", "AgentToastEvent" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = AgentOutgoingEvent.model_construct()
        error_messages = []
        match = 0
        # validate data type: AgentScheduledEvent
        if not isinstance(v, AgentScheduledEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AgentScheduledEvent`")
        else:
            match += 1
        # validate data type: AgentRunScheduledEvent
        if not isinstance(v, AgentRunScheduledEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AgentRunScheduledEvent`")
        else:
            match += 1
        # validate data type: AgentErrorEvent
        if not isinstance(v, AgentErrorEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AgentErrorEvent`")
        else:
            match += 1
        # validate data type: AgentToastEvent
        if not isinstance(v, AgentToastEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AgentToastEvent`")
        else:
            match += 1
        # validate data type: AgentConnectedEvent
        if not isinstance(v, AgentConnectedEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AgentConnectedEvent`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in AgentOutgoingEvent with oneOf schemas: AgentConnectedEvent, AgentErrorEvent, AgentRunScheduledEvent, AgentScheduledEvent, AgentToastEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in AgentOutgoingEvent with oneOf schemas: AgentConnectedEvent, AgentErrorEvent, AgentRunScheduledEvent, AgentScheduledEvent, AgentToastEvent. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `AgentConnectedEvent`
        if _data_type == "AgentConnectedEvent":
            instance.actual_instance = AgentConnectedEvent.from_json(json_str)
            return instance

        # check if data type is `AgentErrorEvent`
        if _data_type == "AgentErrorEvent":
            instance.actual_instance = AgentErrorEvent.from_json(json_str)
            return instance

        # check if data type is `AgentRunScheduledEvent`
        if _data_type == "AgentRunScheduledEvent":
            instance.actual_instance = AgentRunScheduledEvent.from_json(json_str)
            return instance

        # check if data type is `AgentScheduledEvent`
        if _data_type == "AgentScheduledEvent":
            instance.actual_instance = AgentScheduledEvent.from_json(json_str)
            return instance

        # check if data type is `AgentToastEvent`
        if _data_type == "AgentToastEvent":
            instance.actual_instance = AgentToastEvent.from_json(json_str)
            return instance

        # deserialize data into AgentScheduledEvent
        try:
            instance.actual_instance = AgentScheduledEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AgentRunScheduledEvent
        try:
            instance.actual_instance = AgentRunScheduledEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AgentErrorEvent
        try:
            instance.actual_instance = AgentErrorEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AgentToastEvent
        try:
            instance.actual_instance = AgentToastEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AgentConnectedEvent
        try:
            instance.actual_instance = AgentConnectedEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into AgentOutgoingEvent with oneOf schemas: AgentConnectedEvent, AgentErrorEvent, AgentRunScheduledEvent, AgentScheduledEvent, AgentToastEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into AgentOutgoingEvent with oneOf schemas: AgentConnectedEvent, AgentErrorEvent, AgentRunScheduledEvent, AgentScheduledEvent, AgentToastEvent. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AgentConnectedEvent, AgentErrorEvent, AgentRunScheduledEvent, AgentScheduledEvent, AgentToastEvent]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


