# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from mtmai.clients.rest.models.assistant_agent import AssistantAgent
from mtmai.clients.rest.models.instagram_agent import InstagramAgent
from mtmai.clients.rest.models.user_proxy_agent import UserProxyAgent
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

AGENTS_ONE_OF_SCHEMAS = ["AssistantAgent", "InstagramAgent", "UserProxyAgent"]

class Agents(BaseModel):
    """
    Agents
    """
    # data type: AssistantAgent
    oneof_schema_1_validator: Optional[AssistantAgent] = None
    # data type: InstagramAgent
    oneof_schema_2_validator: Optional[InstagramAgent] = None
    # data type: UserProxyAgent
    oneof_schema_3_validator: Optional[UserProxyAgent] = None
    actual_instance: Optional[Union[AssistantAgent, InstagramAgent, UserProxyAgent]] = None
    one_of_schemas: Set[str] = { "AssistantAgent", "InstagramAgent", "UserProxyAgent" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = Agents.model_construct()
        error_messages = []
        match = 0
        # validate data type: AssistantAgent
        if not isinstance(v, AssistantAgent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AssistantAgent`")
        else:
            match += 1
        # validate data type: InstagramAgent
        if not isinstance(v, InstagramAgent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InstagramAgent`")
        else:
            match += 1
        # validate data type: UserProxyAgent
        if not isinstance(v, UserProxyAgent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UserProxyAgent`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in Agents with oneOf schemas: AssistantAgent, InstagramAgent, UserProxyAgent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in Agents with oneOf schemas: AssistantAgent, InstagramAgent, UserProxyAgent. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("provider")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `provider` in the input.")

        # check if data type is `AssistantAgent`
        if _data_type == "AssistantAgent":
            instance.actual_instance = AssistantAgent.from_json(json_str)
            return instance

        # check if data type is `InstagramAgent`
        if _data_type == "InstagramAgent":
            instance.actual_instance = InstagramAgent.from_json(json_str)
            return instance

        # check if data type is `UserProxyAgent`
        if _data_type == "UserProxyAgent":
            instance.actual_instance = UserProxyAgent.from_json(json_str)
            return instance

        # deserialize data into AssistantAgent
        try:
            instance.actual_instance = AssistantAgent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into InstagramAgent
        try:
            instance.actual_instance = InstagramAgent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UserProxyAgent
        try:
            instance.actual_instance = UserProxyAgent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into Agents with oneOf schemas: AssistantAgent, InstagramAgent, UserProxyAgent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Agents with oneOf schemas: AssistantAgent, InstagramAgent, UserProxyAgent. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AssistantAgent, InstagramAgent, UserProxyAgent]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


