# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from mtmai.clients.rest.models.agent_component import AgentComponent
from mtmai.clients.rest.models.instagram_agent_component import InstagramAgentComponent
from mtmai.clients.rest.models.instagram_team_component import InstagramTeamComponent
from mtmai.clients.rest.models.round_robin_group_chat_component import RoundRobinGroupChatComponent
from mtmai.clients.rest.models.selector_group_chat_component import SelectorGroupChatComponent
from mtmai.clients.rest.models.termination_component import TerminationComponent
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

MTCOMPONENTALLOFCOMPONENT_ONE_OF_SCHEMAS = ["AgentComponent", "InstagramAgentComponent", "InstagramTeamComponent", "RoundRobinGroupChatComponent", "SelectorGroupChatComponent", "TerminationComponent"]

class MtComponentAllOfComponent(BaseModel):
    """
    MtComponentAllOfComponent
    """
    # data type: TerminationComponent
    oneof_schema_1_validator: Optional[TerminationComponent] = None
    # data type: AgentComponent
    oneof_schema_2_validator: Optional[AgentComponent] = None
    # data type: InstagramAgentComponent
    oneof_schema_3_validator: Optional[InstagramAgentComponent] = None
    # data type: RoundRobinGroupChatComponent
    oneof_schema_4_validator: Optional[RoundRobinGroupChatComponent] = None
    # data type: SelectorGroupChatComponent
    oneof_schema_5_validator: Optional[SelectorGroupChatComponent] = None
    # data type: InstagramTeamComponent
    oneof_schema_6_validator: Optional[InstagramTeamComponent] = None
    actual_instance: Optional[Union[AgentComponent, InstagramAgentComponent, InstagramTeamComponent, RoundRobinGroupChatComponent, SelectorGroupChatComponent, TerminationComponent]] = None
    one_of_schemas: Set[str] = { "AgentComponent", "InstagramAgentComponent", "InstagramTeamComponent", "RoundRobinGroupChatComponent", "SelectorGroupChatComponent", "TerminationComponent" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = MtComponentAllOfComponent.model_construct()
        error_messages = []
        match = 0
        # validate data type: TerminationComponent
        if not isinstance(v, TerminationComponent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TerminationComponent`")
        else:
            match += 1
        # validate data type: AgentComponent
        if not isinstance(v, AgentComponent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AgentComponent`")
        else:
            match += 1
        # validate data type: InstagramAgentComponent
        if not isinstance(v, InstagramAgentComponent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InstagramAgentComponent`")
        else:
            match += 1
        # validate data type: RoundRobinGroupChatComponent
        if not isinstance(v, RoundRobinGroupChatComponent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RoundRobinGroupChatComponent`")
        else:
            match += 1
        # validate data type: SelectorGroupChatComponent
        if not isinstance(v, SelectorGroupChatComponent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SelectorGroupChatComponent`")
        else:
            match += 1
        # validate data type: InstagramTeamComponent
        if not isinstance(v, InstagramTeamComponent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InstagramTeamComponent`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in MtComponentAllOfComponent with oneOf schemas: AgentComponent, InstagramAgentComponent, InstagramTeamComponent, RoundRobinGroupChatComponent, SelectorGroupChatComponent, TerminationComponent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in MtComponentAllOfComponent with oneOf schemas: AgentComponent, InstagramAgentComponent, InstagramTeamComponent, RoundRobinGroupChatComponent, SelectorGroupChatComponent, TerminationComponent. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into TerminationComponent
        try:
            instance.actual_instance = TerminationComponent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AgentComponent
        try:
            instance.actual_instance = AgentComponent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into InstagramAgentComponent
        try:
            instance.actual_instance = InstagramAgentComponent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RoundRobinGroupChatComponent
        try:
            instance.actual_instance = RoundRobinGroupChatComponent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SelectorGroupChatComponent
        try:
            instance.actual_instance = SelectorGroupChatComponent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into InstagramTeamComponent
        try:
            instance.actual_instance = InstagramTeamComponent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into MtComponentAllOfComponent with oneOf schemas: AgentComponent, InstagramAgentComponent, InstagramTeamComponent, RoundRobinGroupChatComponent, SelectorGroupChatComponent, TerminationComponent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into MtComponentAllOfComponent with oneOf schemas: AgentComponent, InstagramAgentComponent, InstagramTeamComponent, RoundRobinGroupChatComponent, SelectorGroupChatComponent, TerminationComponent. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AgentComponent, InstagramAgentComponent, InstagramTeamComponent, RoundRobinGroupChatComponent, SelectorGroupChatComponent, TerminationComponent]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


