# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from mtmai.clients.rest.models.assistant_agent_config import AssistantAgentConfig
from mtmai.clients.rest.models.instagram_agent_config import InstagramAgentConfig
from mtmai.clients.rest.models.instagram_team_config import InstagramTeamConfig
from mtmai.clients.rest.models.model_config import ModelConfig
from mtmai.clients.rest.models.round_robin_group_chat_config import RoundRobinGroupChatConfig
from mtmai.clients.rest.models.selector_group_chat_config import SelectorGroupChatConfig
from mtmai.clients.rest.models.system_config import SystemConfig
from mtmai.clients.rest.models.tenant_component_config import TenantComponentConfig
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

MTCOMPONENTALLOFCONFIG_ONE_OF_SCHEMAS = ["AssistantAgentConfig", "InstagramAgentConfig", "InstagramTeamConfig", "ModelConfig", "RoundRobinGroupChatConfig", "SelectorGroupChatConfig", "SystemConfig", "TenantComponentConfig"]

class MtComponentAllOfConfig(BaseModel):
    """
    MtComponentAllOfConfig
    """
    # data type: SystemConfig
    oneof_schema_1_validator: Optional[SystemConfig] = None
    # data type: InstagramTeamConfig
    oneof_schema_2_validator: Optional[InstagramTeamConfig] = None
    # data type: InstagramAgentConfig
    oneof_schema_3_validator: Optional[InstagramAgentConfig] = None
    # data type: AssistantAgentConfig
    oneof_schema_4_validator: Optional[AssistantAgentConfig] = None
    # data type: RoundRobinGroupChatConfig
    oneof_schema_5_validator: Optional[RoundRobinGroupChatConfig] = None
    # data type: SelectorGroupChatConfig
    oneof_schema_6_validator: Optional[SelectorGroupChatConfig] = None
    # data type: ModelConfig
    oneof_schema_7_validator: Optional[ModelConfig] = None
    # data type: TenantComponentConfig
    oneof_schema_8_validator: Optional[TenantComponentConfig] = None
    actual_instance: Optional[Union[AssistantAgentConfig, InstagramAgentConfig, InstagramTeamConfig, ModelConfig, RoundRobinGroupChatConfig, SelectorGroupChatConfig, SystemConfig, TenantComponentConfig]] = None
    one_of_schemas: Set[str] = { "AssistantAgentConfig", "InstagramAgentConfig", "InstagramTeamConfig", "ModelConfig", "RoundRobinGroupChatConfig", "SelectorGroupChatConfig", "SystemConfig", "TenantComponentConfig" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = MtComponentAllOfConfig.model_construct()
        error_messages = []
        match = 0
        # validate data type: SystemConfig
        if not isinstance(v, SystemConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SystemConfig`")
        else:
            match += 1
        # validate data type: InstagramTeamConfig
        if not isinstance(v, InstagramTeamConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InstagramTeamConfig`")
        else:
            match += 1
        # validate data type: InstagramAgentConfig
        if not isinstance(v, InstagramAgentConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InstagramAgentConfig`")
        else:
            match += 1
        # validate data type: AssistantAgentConfig
        if not isinstance(v, AssistantAgentConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AssistantAgentConfig`")
        else:
            match += 1
        # validate data type: RoundRobinGroupChatConfig
        if not isinstance(v, RoundRobinGroupChatConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RoundRobinGroupChatConfig`")
        else:
            match += 1
        # validate data type: SelectorGroupChatConfig
        if not isinstance(v, SelectorGroupChatConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SelectorGroupChatConfig`")
        else:
            match += 1
        # validate data type: ModelConfig
        if not isinstance(v, ModelConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ModelConfig`")
        else:
            match += 1
        # validate data type: TenantComponentConfig
        if not isinstance(v, TenantComponentConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TenantComponentConfig`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in MtComponentAllOfConfig with oneOf schemas: AssistantAgentConfig, InstagramAgentConfig, InstagramTeamConfig, ModelConfig, RoundRobinGroupChatConfig, SelectorGroupChatConfig, SystemConfig, TenantComponentConfig. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in MtComponentAllOfConfig with oneOf schemas: AssistantAgentConfig, InstagramAgentConfig, InstagramTeamConfig, ModelConfig, RoundRobinGroupChatConfig, SelectorGroupChatConfig, SystemConfig, TenantComponentConfig. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into SystemConfig
        try:
            instance.actual_instance = SystemConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into InstagramTeamConfig
        try:
            instance.actual_instance = InstagramTeamConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into InstagramAgentConfig
        try:
            instance.actual_instance = InstagramAgentConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AssistantAgentConfig
        try:
            instance.actual_instance = AssistantAgentConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RoundRobinGroupChatConfig
        try:
            instance.actual_instance = RoundRobinGroupChatConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SelectorGroupChatConfig
        try:
            instance.actual_instance = SelectorGroupChatConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ModelConfig
        try:
            instance.actual_instance = ModelConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TenantComponentConfig
        try:
            instance.actual_instance = TenantComponentConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into MtComponentAllOfConfig with oneOf schemas: AssistantAgentConfig, InstagramAgentConfig, InstagramTeamConfig, ModelConfig, RoundRobinGroupChatConfig, SelectorGroupChatConfig, SystemConfig, TenantComponentConfig. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into MtComponentAllOfConfig with oneOf schemas: AssistantAgentConfig, InstagramAgentConfig, InstagramTeamConfig, ModelConfig, RoundRobinGroupChatConfig, SelectorGroupChatConfig, SystemConfig, TenantComponentConfig. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AssistantAgentConfig, InstagramAgentConfig, InstagramTeamConfig, ModelConfig, RoundRobinGroupChatConfig, SelectorGroupChatConfig, SystemConfig, TenantComponentConfig]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


